Index: branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/DataAnalysisExperimentWizard.cs
===================================================================
--- branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/DataAnalysisExperimentWizard.cs	(revision 7824)
+++ branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/DataAnalysisExperimentWizard.cs	(revision 7912)
@@ -14,5 +14,6 @@
       wizard.AddPage(new SelectAnalysisPage(context));
       wizard.AddPage(new WizardPage());
-      wizard.AddPage(new MediumAnalysisPage());
+      wizard.AddPage(new MediumAnalysisPage(context));
+      wizard.AddPage(new ExperimentViewPage(context));
 
     }
Index: branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/DataAnalysisWizardContext.cs
===================================================================
--- branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/DataAnalysisWizardContext.cs	(revision 7824)
+++ branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/DataAnalysisWizardContext.cs	(revision 7912)
@@ -1,3 +1,4 @@
 ﻿
+using HeuristicLab.Optimization;
 using HeuristicLab.Problems.DataAnalysis;
 namespace HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard {
@@ -5,4 +6,5 @@
     public IDataAnalysisProblem Problem { get; set; }
     public string SelectedAnalysis { get; set; }
+    public Experiment Experiment { get; set; }
   }
 }
Index: branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard.csproj
===================================================================
--- branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard.csproj	(revision 7824)
+++ branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard.csproj	(revision 7912)
@@ -38,4 +38,5 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Algorithms.DataAnalysis-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Algorithms.DataAnalysis.Views-3.4">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Algorithms.DataAnalysis.Views-3.4.dll</HintPath>
@@ -108,4 +109,10 @@
     <Compile Include="DataAnalysisExperimentWizard.cs" />
     <Compile Include="DataAnalysisWizardContext.cs" />
+    <Compile Include="ExperimentViewPage.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ExperimentViewPage.Designer.cs">
+      <DependentUpon>ExperimentViewPage.cs</DependentUpon>
+    </Compile>
     <Compile Include="ExperimentWizardMenuItem.cs" />
     <Compile Include="MediumAnalysisPage.cs">
@@ -142,4 +149,7 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="ExperimentViewPage.resx">
+      <DependentUpon>ExperimentViewPage.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="MediumAnalysisPage.resx">
       <DependentUpon>MediumAnalysisPage.cs</DependentUpon>
@@ -156,4 +166,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.ParameterConfigurationTreeEncoding\3.3\HeuristicLab.Encodings.ParameterConfigurationTreeEncoding.csproj">
+      <Project>{8BF5F8CB-C876-4EA6-B6D7-F0D8B14DDF6E}</Project>
+      <Name>HeuristicLab.Encodings.ParameterConfigurationTreeEncoding</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.ExperimentGeneration.DataAnalysis.Wizard\3.3\HeuristicLab.ExperimentGeneration.DataAnalysis.Wizard.csproj">
       <Project>{77169FE1-C48A-49AE-A0DD-67921D7835AB}</Project>
Index: branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/MediumAnalysisPage.Designer.cs
===================================================================
--- branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/MediumAnalysisPage.Designer.cs	(revision 7824)
+++ branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/MediumAnalysisPage.Designer.cs	(revision 7912)
@@ -24,4 +24,5 @@
     /// </summary>
     private void InitializeComponent() {
+      this.progressBar1 = new System.Windows.Forms.ProgressBar();
       this.label1 = new System.Windows.Forms.Label();
       this.SuspendLayout();
@@ -32,11 +33,19 @@
       this.wizardBanner.Title = "Medium Analysis";
       // 
+      // progressBar1
+      // 
+      this.progressBar1.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.progressBar1.Location = new System.Drawing.Point(0, 143);
+      this.progressBar1.Name = "progressBar1";
+      this.progressBar1.Size = new System.Drawing.Size(320, 23);
+      this.progressBar1.TabIndex = 2;
+      // 
       // label1
       // 
       this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(106, 124);
+      this.label1.Location = new System.Drawing.Point(0, 124);
       this.label1.Name = "label1";
       this.label1.Size = new System.Drawing.Size(35, 13);
-      this.label1.TabIndex = 1;
+      this.label1.TabIndex = 3;
       this.label1.Text = "label1";
       // 
@@ -45,6 +54,9 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.Controls.Add(this.label1);
+      this.Controls.Add(this.progressBar1);
       this.Name = "MediumAnalysisPage";
+      this.SetActive += new System.ComponentModel.CancelEventHandler(this.MediumAnalysisPage_SetActive);
       this.WizardBack += new HeuristicLab.ExperimentGeneration.DataAnalysis.Wizard.WizardPageEventHandler(this.MediumAnalysisPage_WizardBack);
+      this.Controls.SetChildIndex(this.progressBar1, 0);
       this.Controls.SetChildIndex(this.label1, 0);
       this.Controls.SetChildIndex(this.wizardBanner, 0);
@@ -56,5 +68,7 @@
     #endregion
 
+    private System.Windows.Forms.ProgressBar progressBar1;
     private System.Windows.Forms.Label label1;
+
   }
 }
Index: branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/MediumAnalysisPage.cs
===================================================================
--- branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/MediumAnalysisPage.cs	(revision 7824)
+++ branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/MediumAnalysisPage.cs	(revision 7912)
@@ -1,7 +1,60 @@
 ﻿
+using System.ComponentModel;
+using System.Linq;
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ParameterConfigurationTreeEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis;
 namespace HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard {
   public partial class MediumAnalysisPage : HeuristicLab.ExperimentGeneration.DataAnalysis.Wizard.WizardPage {
-    public MediumAnalysisPage() {
+    private BackgroundWorker worker;
+
+    private DataAnalysisWizardContext context;
+    public DataAnalysisWizardContext Context {
+      get { return context; }
+    }
+
+    public MediumAnalysisPage(DataAnalysisWizardContext context) {
       InitializeComponent();
+      this.context = context;
+      worker = new BackgroundWorker();
+      worker.DoWork += new DoWorkEventHandler(GenerateExperimentsTask);
+      worker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(WorkerCompleted);
+
+    }
+
+    private void GenerateExperimentsTask(object sender, DoWorkEventArgs e) {
+      DataAnalysisWizardContext c = e.Argument as DataAnalysisWizardContext;
+      IProblem problem = c.Problem;
+      SupportVectorRegression svr = new SupportVectorRegression();
+      svr.Problem = (IRegressionProblem)problem;
+      ParameterConfigurationTree vc = new ParameterConfigurationTree(svr, problem);
+      var nuPc = vc.AlgorithmConfiguration.ParameterConfigurations.Where(x => x.ParameterName == "Nu").SingleOrDefault();
+      nuPc.Optimize = true;
+      var nuVc = (RangeValueConfiguration)nuPc.ValueConfigurations.First();
+      nuVc.Optimize = true;
+      nuVc.RangeConstraint = new DoubleValueRange(new DoubleValue(0.1), new DoubleValue(0.9), new DoubleValue(0.1));
+
+      var costPc = vc.AlgorithmConfiguration.ParameterConfigurations.Where(x => x.ParameterName == "Cost").SingleOrDefault();
+      costPc.Optimize = true;
+      var costVc = (RangeValueConfiguration)costPc.ValueConfigurations.First();
+      costVc.Optimize = true;
+      costVc.RangeConstraint = new DoubleValueFactorRange(new DoubleValue(0.03125), new DoubleValue(32768), new DoubleValue(4));
+
+      var gammaPc = vc.AlgorithmConfiguration.ParameterConfigurations.Where(x => x.ParameterName == "Gamma").SingleOrDefault();
+      gammaPc.Optimize = true;
+      var gammaVc = (RangeValueConfiguration)gammaPc.ValueConfigurations.First();
+      gammaVc.Optimize = true;
+      gammaVc.RangeConstraint = new DoubleValueFactorRange(new DoubleValue(6.10352E-05), new DoubleValue(64), new DoubleValue(4));
+
+      Experiment experiment = vc.GenerateExperiment(svr);
+      e.Result = experiment;
+    }
+
+    private void WorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
+      SetWizardButton(Wizard.WizardButtons.Next);
+      Experiment experiment = (Experiment)e.Result;
+      context.Experiment = experiment;
     }
 
@@ -9,4 +62,9 @@
       e.NewPage = "SelectAnalysisPage";
     }
+
+    private void MediumAnalysisPage_SetActive(object sender, System.ComponentModel.CancelEventArgs e) {
+      SetWizardButton(Wizard.WizardButtons.None);
+      worker.RunWorkerAsync(context);
+    }
   }
 }
Index: branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/Plugin.cs.frame
===================================================================
--- branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/Plugin.cs.frame	(revision 7824)
+++ branches/DataAnalysisService/HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard/3.3/Plugin.cs.frame	(revision 7912)
@@ -29,4 +29,5 @@
   [PluginFile("HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Algorithms.DataAnalysis.Views", "3.4")]
+  [PluginDependency("HeuristicLab.Algorithms.DataAnalysis", "3.4")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
@@ -36,4 +37,5 @@
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Data.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.ParameterConfigurationTreeEncoding", "3.3")]
   [PluginDependency("HeuristicLab.ExperimentGeneration.DataAnalysis.Wizard", "3.3")]
   [PluginDependency("HeuristicLab.MainForm", "3.3")]